﻿using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
//u reference treba dodati System.Runtime.Remoting

namespace Server
{
    public interface INeka
    {
        string DajRezultat();
    }
    public class TalkServer : MarshalByRefObject { // zajednicka klasa koja ce se vrtiti na serveru
        public void Ispisi(string s)
        {
            Console.WriteLine(s);
        }
        public void PostaviObj(INeka i)
        {
            Console.WriteLine("Rezultat je : {0}", i.DajRezultat());
        }
    }   
    class Program
    {
        static void Main(string[] args)
        {
            TcpChannel chan = new TcpChannel(12345);
            ChannelServices.RegisterChannel(chan);
            RemotingConfiguration.RegisterWellKnownServiceType(
                typeof(TalkServer),
                "TalkServer",
                WellKnownObjectMode.Singleton); // Singleton mozemo shvatiti kao staticki objekt za cijeli host
            // svaki klijent dobiva referencu na isti objekt, i vrti se u svom threadu
            Console.ReadLine();
        }
    }
}